var Build, Http, Url;
Url = require("url");
Http = require("http");
Build = (function() {
  function Build(host, name, number, data) {
    var action, hash, info, params, payload;
    this.host = host;
    this.name = name;
    this.number = number;
    this.data = data;
    this.sha1 = "0000000000000000000000000000000000000000";
    this.branch = "master";
    this.compare = "";
    this.output = "" + this.host + "/job/" + this.name + "/" + this.number + "/consoleText";
    switch (this.data.result) {
      case "SUCCESS":
        this.status = "successful";
        break;
      case "FAILURE":
        this.status = "failed";
        break;
      default:
        this.status = "building";
    }
    this.statusClass = this.statusClass();
    info = (function() {
      var _i, _len, _ref, _results;
      _ref = this.data.actions;
      _results = [];
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        action = _ref[_i];
        if (action.parameters) {
          _results.push(action);
        }
      }
      return _results;
    }).call(this);
    if (info[0]) {
      params = info[0].parameters;
      this.branch = ((function() {
        var _i, _len, _results;
        _results = [];
        for (_i = 0, _len = params.length; _i < _len; _i++) {
          hash = params[_i];
          if (hash.name === "GITHUB_BRANCH") {
            _results.push(hash.value);
          }
        }
        return _results;
      })())[0];
      payload = ((function() {
        var _i, _len, _results;
        _results = [];
        for (_i = 0, _len = params.length; _i < _len; _i++) {
          hash = params[_i];
          if (hash.name === "GITHUB_PAYLOAD") {
            _results.push(hash.value);
          }
        }
        return _results;
      })())[0];
      if (payload && payload.length > 2) {
        try {
          this.payload = payload.slice(1, payload.length - 1);
          this.payload = JSON.parse(this.payload);
          if (this.payload.after) {
            this.sha1 = this.payload.after;
          }
          if (this.payload.ref) {
            this.branch = this.payload.ref.split("/")[2];
          }
        } catch (_e) {}
      }
    }
  }
  Build.prototype.consoleText = function(callback) {
    var client, request, result, url;
    result = "";
    url = Url.parse(this.output);
    client = Http.createClient(url.port, url.hostname);
    client.on('error', function(err) {
      console.log(url);
      console.log("Unable to connect to " + this.host + ", did you set a JENKINS_SERVER environmental variable?");
      return callback(err, {});
    });
    request = client.request('GET', url.pathname, {
      'host': url.hostname
    });
    request.on('response', function(response) {
      response.on('end', function() {
        if (response.statusCode === 200) {
          return callback(null, result);
        } else {
          return callback(null, "Unable to fetch the output\nWTF\n");
        }
      });
      response.on('data', function(chunk) {
        return result += chunk;
      });
      return response.on('error', function(err) {
        return callback(err, {});
      });
    });
    return request.end();
  };
  Build.prototype.statusClass = function() {
    switch (this.status) {
      case 'successful':
        return 'good';
      case 'building':
        return 'building';
      default:
        return 'janky';
    }
  };
  return Build;
})();
exports.Build = Build;