var Build, HttpRequest, Job, Map, Server;
Job = require("jenkins/job").Job;
Map = require("async").map;
Build = require("jenkins/build").Build;
HttpRequest = require("jenkins/utils/http_request").HttpRequest;
Server = (function() {
  function Server(host) {
    this.host = host;
    this.client = new HttpRequest(this.host);
    this.url = this.client.url;
  }
  Server.prototype.job_for = function(name) {
    return new Job(this.host, name);
  };
  Server.prototype.job_names = function(callback) {
    return this.jobs(function(err, jobs) {
      var job;
      return callback(err, (function() {
        var _i, _len, _results;
        _results = [];
        for (_i = 0, _len = jobs.length; _i < _len; _i++) {
          job = jobs[_i];
          _results.push(job.name);
        }
        return _results;
      })());
    });
  };
  Server.prototype.jobs = function(callback) {
    var self;
    self = this;
    return this.client.fetch("/api/json", function(err, data) {
      var job;
      return callback(err, (function() {
        var _i, _len, _ref, _results;
        _ref = data.jobs;
        _results = [];
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          job = _ref[_i];
          _results.push(self.job_for(job.name));
        }
        return _results;
      })());
    });
  };
  Server.prototype.jobs_info = function(callback) {
    var info_callback;
    info_callback = function(job, infoCallback) {
      return job.branches_for("master", function(err, data) {
        return infoCallback(err, data[0]);
      });
    };
    return this.jobs(function(err, jobs) {
      return Map(jobs, info_callback, function(err, results) {
        return callback(err, results);
      });
    });
  };
  return Server;
})();
exports.Job = Job;
exports.Build = Build;
exports.Server = Server;