var Http, HttpRequest, Url;
Url = require("url");
Http = require("http");
HttpRequest = (function() {
  function HttpRequest(host) {
    this.host = host;
    this.url = Url.parse(this.host);
    this.port = this.url.port;
    this.path = this.url.pathname || "";
    this.hostname = this.url.hostname;
  }
  HttpRequest.prototype.fetch = function(path, callback) {
    var headers, params, request, result;
    result = "";
    headers = {
      "Accept": "application/json"
    };
    params = {
      "host": this.hostname,
      "port": this.port,
      "path": "" + this.path + path,
      "headers": headers
    };
    console.log(params);
    request = Http.request(params, function(response) {
      response.on("end", function() {
        if (response.statusCode === 200) {
          return callback(null, JSON.parse(result));
        } else {
          return callback(null, {
            "error": response.statusCode,
            "actions": [],
            "jobs": []
          });
        }
      });
      response.on("data", function(chunk) {
        return result += chunk;
      });
      return response.on("error", function(err) {
        return callback(err, {});
      });
    });
    return request.end();
  };
  return HttpRequest;
})();
exports.HttpRequest = HttpRequest;