var Http, JobBuildRequest, QueryString, Url;
Url = require("url");
Http = require("http");
QueryString = require("querystring");
JobBuildRequest = (function() {
  function JobBuildRequest(url, name, branch, payload) {
    this.url = url;
    this.name = name;
    this.branch = branch;
    this.payload = payload;
    this.port = this.url.port;
    this.path = "/job/" + this.name + "/build";
    this.hostname = this.url.hostname;
    this.options = {
      parameter: [
        {
          "name": "GITHUB_BRANCH",
          "value": this.branch
        }, {
          "name": "GITHUB_PAYLOAD",
          "value": this.payload
        }
      ]
    };
  }
  JobBuildRequest.prototype.trigger = function(callback) {
    var client, data, postParams, request, result;
    result = "";
    client = Http.createClient(this.port, this.hostname);
    client.on("error", function(err) {
      console.log("Unable to connect to " + this.host + ", did you set a JENKINS_SERVER environmental variable?");
      return callback(err, {});
    });
    data = QueryString.stringify({
      json: JSON.stringify(this.options)
    }, "&", "=", false);
    postParams = {
      "host": this.hostname,
      "Content-Length": data.length,
      "Content-Type": "application/x-www-form-urlencoded"
    };
    request = client.request("POST", this.path, postParams);
    request.on("response", function(response) {
      response.on("end", function() {
        return callback(null, {
          "status": response.statusCode === 302
        });
      });
      response.on("data", function(chunk) {
        return result += chunk;
      });
      return response.on("error", function(err) {
        return callback(err, {});
      });
    });
    return request.end(data);
  };
  return JobBuildRequest;
})();
exports.JobBuildRequest = JobBuildRequest;